
package org.mule.module.magento.config;

import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.mule.config.spring.MuleHierarchicalBeanDefinitionParserDelegate;
import org.mule.config.spring.util.SpringXMLUtils;
import org.mule.module.magento.processors.SetShoppingCartPaymentMethodMessageProcessor;
import org.mule.util.TemplateParser;
import org.springframework.beans.MutablePropertyValues;
import org.springframework.beans.PropertyValue;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.config.RuntimeBeanReference;
import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.support.ManagedList;
import org.springframework.beans.factory.support.ManagedMap;
import org.springframework.beans.factory.xml.BeanDefinitionParser;
import org.springframework.beans.factory.xml.ParserContext;
import org.springframework.util.xml.DomUtils;
import org.w3c.dom.Element;

public class SetShoppingCartPaymentMethodDefinitionParser
    implements BeanDefinitionParser
{

    /**
     * Mule Pattern Info
     * 
     */
    private TemplateParser.PatternInfo patternInfo;

    public SetShoppingCartPaymentMethodDefinitionParser() {
        patternInfo = TemplateParser.createMuleStyleParser().getStyle();
    }

    public BeanDefinition parse(Element element, ParserContext parserContent) {
        BeanDefinitionBuilder builder = BeanDefinitionBuilder.rootBeanDefinition(SetShoppingCartPaymentMethodMessageProcessor.class.getName());
        String configRef = element.getAttribute("config-ref");
        if ((configRef!= null)&&(!StringUtils.isBlank(configRef))) {
            builder.addPropertyValue("moduleObject", configRef);
        }
        if ((element.getAttribute("quoteId")!= null)&&(!StringUtils.isBlank(element.getAttribute("quoteId")))) {
            builder.addPropertyValue("quoteId", element.getAttribute("quoteId"));
        }
        Element methodListElement = null;
        methodListElement = DomUtils.getChildElementByTagName(element, "method");
        List<Element> methodMapChilds = null;
        if (methodListElement!= null) {
            String methodRef = methodListElement.getAttribute("ref");
            if ((methodRef!= null)&&(!StringUtils.isBlank(methodRef))) {
                if ((!methodRef.startsWith(patternInfo.getPrefix()))&&(!methodRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("method", new RuntimeBeanReference(methodRef));
                } else {
                    builder.addPropertyValue("method", methodRef);
                }
            } else {
                ManagedMap method = new ManagedMap();
                methodMapChilds = DomUtils.getChildElementsByTagName(methodListElement, "method");
                if (methodMapChilds!= null) {
                    if (methodMapChilds.size() == 0) {
                        methodMapChilds = DomUtils.getChildElements(methodListElement);
                    }
                    for (Element methodChild: methodMapChilds) {
                        String methodValueRef = methodChild.getAttribute("value-ref");
                        String methodKeyRef = methodChild.getAttribute("key-ref");
                        Object valueObject = null;
                        Object keyObject = null;
                        if ((methodValueRef!= null)&&(!StringUtils.isBlank(methodValueRef))) {
                            if ((!methodValueRef.startsWith(patternInfo.getPrefix()))&&(!methodValueRef.endsWith(patternInfo.getSuffix()))) {
                                valueObject = new RuntimeBeanReference(methodValueRef);
                            } else {
                                valueObject = methodValueRef;
                            }
                        } else {
                            valueObject = methodChild.getTextContent();
                        }
                        if ((methodKeyRef!= null)&&(!StringUtils.isBlank(methodKeyRef))) {
                            keyObject = new RuntimeBeanReference(methodKeyRef);
                        } else {
                            keyObject = methodChild.getAttribute("key");
                        }
                        if ((keyObject == null)||((keyObject instanceof String)&&StringUtils.isBlank(((String) keyObject)))) {
                            keyObject = methodChild.getTagName();
                        }
                        method.put(keyObject, valueObject);
                    }
                }
                builder.addPropertyValue("method", method);
            }
        }
        if ((element.getAttribute("storeId")!= null)&&(!StringUtils.isBlank(element.getAttribute("storeId")))) {
            builder.addPropertyValue("storeId", element.getAttribute("storeId"));
        }
        BeanDefinition definition = builder.getBeanDefinition();
        definition.setAttribute(MuleHierarchicalBeanDefinitionParserDelegate.MULE_NO_RECURSE, Boolean.TRUE);
        MutablePropertyValues propertyValues = parserContent.getContainingBeanDefinition().getPropertyValues();
        if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.config.spring.factories.PollingMessageSourceFactoryBean")) {
            propertyValues.addPropertyValue("messageProcessor", definition);
        } else {
            if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.enricher.MessageEnricher")) {
                propertyValues.addPropertyValue("enrichmentMessageProcessor", definition);
            } else {
                PropertyValue messageProcessors = propertyValues.getPropertyValue("messageProcessors");
                if ((messageProcessors == null)||(messageProcessors.getValue() == null)) {
                    propertyValues.addPropertyValue("messageProcessors", new ManagedList());
                }
                List listMessageProcessors = ((List) propertyValues.getPropertyValue("messageProcessors").getValue());
                listMessageProcessors.add(definition);
            }
        }
        return definition;
    }

    protected String getAttributeValue(Element element, String attributeName) {
        if (!StringUtils.isEmpty(element.getAttribute(attributeName))) {
            return element.getAttribute(attributeName);
        }
        return null;
    }

    private String generateChildBeanName(Element element) {
        String id = SpringXMLUtils.getNameOrId(element);
        if (StringUtils.isBlank(id)) {
            String parentId = SpringXMLUtils.getNameOrId(((Element) element.getParentNode()));
            return ((("."+ parentId)+":")+ element.getLocalName());
        } else {
            return id;
        }
    }

}
